#ifndef __BOOLEANEXPRESSION_H__
#define __BOOLEANEXPRESSION_H__

#include <vector>
#include <stack>

namespace Inter4ql {
	class BooleanExpression
	{
	public:
		BooleanExpression() {};
		~BooleanExpression() {};

		enum Operation_Type { AND, OR, PLUS, MINUS, MUL, DIV};
		enum Comparison_Type { EQ, NEQ, GT, GTE, LT, LTE };
		enum Element_Type { NUMBER, T, F, I, U, ALL, OP, COMP};
		union data_type {
			int number;
			Operation_Type operation;
			Comparison_Type comparison;
		};
		typedef struct bool_elem {
			Element_Type type;
			data_type data;
		} bool_elem;

		void add_element(Element_Type type, data_type data = {0});
		int calculate(int i, int t, int f, int u);
		void add_boolean_expression(BooleanExpression b);

	private:
		std::vector<bool_elem> elems;
	};
}

#endif
