#include "Domain.h"
#include "Types.h"
#include "Functions.h"
#include "Disposable.h"

namespace Inter4ql {

	Domain::Domain(std::string a_name, Inter4ql::variable_type::type a_type)
	: name(a_name)
	, type(a_type)
	{ }

	Domain::Domain(Inter4ql::variable_type::type a_type) {
		this->name = variable_type2string(a_type);
		this->type = a_type;
	}

	Domain::~Domain() {
		if(!Disposable::errorMode) {
			// do nothing!
		} else {
			//std::cout << this->print() << std::endl << std::endl;
			//std::cout << "DELETE DOMAIN*" << std::endl;
		}
	}

	std::string Domain::get_name() const {
		return this->name;
	}

	void Domain::set_type(variable_type::type _t) {
		this->type = _t;
	}

	Inter4ql::variable_type::type Domain::get_type() const {
		return this->type;
	}

	std::string Domain::print() {
		if(variable_type2string(this->type) != this->name)
			return this->name + " (" + variable_type2string(this->type) + ")";
		return this->name;
	}

	bool operator==(const Domain& a, const Domain& b) {
		return a.get_name() == b.get_name() && a.get_type() == b.get_type();
	}

	bool operator!=(const Domain& a, const Domain& b) {
		return a.get_name() != b.get_name() || a.get_type() != b.get_type();
	}

}
