#ifndef __OUTPUT_CC__
#define __OUTPUT_CC__

#include <iostream>
#include "Output.h"
#include "Exception.h"

namespace Inter4ql {

	Output::Output(std::ostream *o, std::ostream *e){
		if(o)
			this->set_output(o);
		else
			this->set_output(&std::cout);
		if(e)
			this->set_error(e);
		else
			this->set_error(&std::cerr);
	}

	Output::~Output(){

	}

	void Output::print(Exception *s) {
		(*(this->err_output)) << s->get();
		return;
	}

	void Output::print(std::string *s) {
		(*(this->std_output)) << *s;
	}

	void Output::print(std::string s) {
		(*(this->std_output)) << s;
	}

	void Output::set_output(std::ostream *o){
		this->std_output = o;
		return ;
	}
	void Output::set_error(std::ostream *e){
		this->err_output = e;
		return ;
	}
}

#endif
