#ifndef __OUTPUT_H__
#define __OUTPUT_H__

#include <string>

namespace Inter4ql {

	class Exception;

	/** @brief Output class handles standard output of interpreter
	 */
	class Output {
	public:
		/** @brief constructor
		 *
		 * @param o standard output
		 * @param e error output
		 */
		Output(std::ostream *o = 0, std::ostream *e = 0);
		/** @brief destructor
		 */
		~Output();
		/** @brief prints exception
		 *
		 * @param s pointer to an Exception instance
		 */
		void print(Exception *s);
		/** @brief prints std::string
		 *
		 * @param s pointer to an std::string
		 */
		void print(std::string *s);
		/** @brief prints std::string
		 *
		 * @param s std::string
		 */
		void print(std::string s);
		/** @brief setter for standard output
		 *
		 * @param o standard output
		 */
		void set_output(std::ostream *o);
		/** @brief setter for error output
		 *
		 * @param e error output
		 */
		void set_error(std::ostream *e);
	private:
		std::ostream *std_output;
		std::ostream *err_output;
	};
}

#endif
