#include "Relation.h"
#include "Domain.h"
#include "Disposable.h"

namespace Inter4ql {

	Relation::Relation(std::string a_name, std::vector<Domain *> *a_params, std::string _module)
	: name(a_name)
	, params(a_params)
	, module(_module)
	, isUnknown(false)
	{}

	Relation::~Relation() {
		if(!Disposable::errorMode) {
			for(std::vector<Domain*>::iterator it = this->params->begin(); it != this->params->end(); it++) {
				delete (*it);
			}
			delete this->params;
		} else {
			//std::cout << "DELETE RELATION*" << std::endl;
		}
	}

	std::vector<Domain*> *Relation::get_params() {
		return this->params;
	}

	std::string Relation::get_name() {
		return this->name;
	}

	bool Relation::is_unknown() {
		return this->isUnknown;
	}

	void Relation::set_unknown(bool value) {
		this->isUnknown = value;
	}

	std::string Relation::get_module() {
		return this->module;
	}

	void Relation::set_module(std::string _m) {
		this->module = _m;
	}

	std::string Relation::print() {
		std::string s("");
		s += this->name + "(" + this->print_params() + ").";
		return s;
	}

	std::string Relation::print_params() {
		std::string s("");
		for (int i = 0; i < this->params->size(); i++) {
			if (i != 0)
				s += ", ";
			s += this->params->at(i)->print();
		}
		return s;
	}
}
