#ifndef BEL_H
#define BEL_H

#include "../ModuleInternal.h"

namespace Inter4ql {

	class VariableSpace;

	/** @brief Math module used to implement basic math operations
	 */
	class Bel : public ModuleInternal {
	public:
		/** @brief constructor for Math module
		 *
		 * @param _v pointer to VariableSpace class
		 */
		explicit Bel(VariableSpace *_v, std::vector<ModuleGeneric *> *_modules);
		~Bel();
		void reason();
		Result ask_for_result(Fact * term) const override;
		module_type::type get_module_type() const;
		std::vector<std::string> get_references(Fact * term) override;

		/** @brief sets modules set needed for computations
		 *
		 * @param _modules current modules from interpreter
		 */
		void set_modules(std::vector<ModuleGeneric *> *_modules) {
			this->modules = _modules;
		}
		/** @brief allows for disabling constraints check
		 *
		 * @param value value to be set
		 */
		void set_disable_constraints(bool value) const override { disable_constraints = value; };
		/** @brief checks whether constraints are violated
		 *
		 * @return true if constraints are vioilated, false otherwise
		 */
		bool constraints_violated() override;
	private:
		std::vector<ModuleGeneric *> *modules;

		mutable bool disable_constraints;
	};
}

#endif  /* BEL_H */

