#ifndef EXTERNAL_H
#define EXTERNAL_H

#include "../ModuleExternal.h"

namespace Inter4ql {

    class VariableSpace;

    /** @brief Plugin module used to implement operations delievered by external applications
     */
    class Plugin : public ModuleExternal {
    public:
        /** @brief constructor for Plugin module
         *
         * @param _v pointer to VariableSpace class
         */
        explicit Plugin(VariableSpace *_v);
        /** @brief Function executing external application
         *
         * @param name name of application to execute
         * @param params list of params for application
         * @return TRUE or FALSE
         */
        static Inter4ql::logic_type::type runPlugin(std::string name, std::string params);
		// ----------------- NEW STUFF ---------------------
		void reason();
		Result ask_for_result(Fact * term) const;

    private:
        void add_relation(std::string name, std::string interface);
    };
}

#endif  /* EXTERNAL_H */

